var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { EmulatedUIEvent } from './EmulatedUIEvent';

export class EmulatedKeyboardEvent extends EmulatedUIEvent {

  getModifierState(key) {
    return this.nativeEvent.getModifierState(key);
  }
}

EmulatedKeyboardEvent.Interface = _extends({}, EmulatedUIEvent.Interface, {
  key: null,
  location: null,
  ctrlKey: null,
  shiftKey: null,
  altKey: null,
  metaKey: null,
  repeat: null,
  locale: null,
  keyCode: null,
  code: null,
  which: null
});
export default EmulatedKeyboardEvent;