var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { EmulatedUIEvent } from './EmulatedUIEvent';

export class EmulatedTouchEvent extends EmulatedUIEvent {

  getModifierState(key) {
    return this.nativeEvent.getModifierState(key);
  }
}

EmulatedTouchEvent.Interface = _extends({}, EmulatedUIEvent.Interface, {
  touches: null,
  targetTouches: null,
  changedTouches: null,
  altKey: null,
  metaKey: null,
  ctrlKey: null,
  shiftKey: null
});
export default EmulatedTouchEvent;