var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { EmulatedEvent } from './EmulatedEvent';

export class EmulatedUIEvent extends EmulatedEvent {}

EmulatedUIEvent.Interface = _extends({}, EmulatedEvent.Interface, {
  view(event) {
    if (event.view) return event.view;
    const target = event.target || event.srcElement || window;
    return target === target.window ? target : window;
  },
  detail: event => event.detail || 0
});
export default EmulatedUIEvent;