'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Scrolljack = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _map = require('rxjs/operator/map');

var _mergeAll = require('rxjs/operator/mergeAll');

var _mergeMap = require('rxjs/operator/mergeMap');

var _takeUntil = require('rxjs/operator/takeUntil');

var _take = require('rxjs/operator/take');

var _throttle = require('rxjs/operator/throttle');

var _DeltaObservable2 = require('./observables/DeltaObservable');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var parseOpts = function parseOpts(target, rootOrDeltaObservableClass) {
  for (var _len = arguments.length, DeltaObservableClasses = Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    DeltaObservableClasses[_key - 2] = arguments[_key];
  }

  var root = rootOrDeltaObservableClass;
  if (!root) {
    root = target;
  } else if (root === _DeltaObservable2.DeltaObservable || root.prototype instanceof _DeltaObservable2.DeltaObservable) {
    DeltaObservableClasses.unshift(root);
    root = target;
  }
  return [target, root, DeltaObservableClasses];
};

var Scrolljack = exports.Scrolljack = function (_DeltaObservable) {
  _inherits(Scrolljack, _DeltaObservable);

  function Scrolljack() {
    _classCallCheck(this, Scrolljack);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Scrolljack).apply(this, arguments));
  }

  _createClass(Scrolljack, null, [{
    key: 'scrollStart',
    value: function scrollStart() {
      var _parseOpts = parseOpts.apply(undefined, arguments);

      var _parseOpts2 = _slicedToArray(_parseOpts, 3);

      var target = _parseOpts2[0];
      var root = _parseOpts2[1];
      var DeltaObservableClasses = _parseOpts2[2];

      var sources = DeltaObservableClasses.map(function (DeltaClass) {
        var _context;

        return (_context = DeltaClass.scrollStart(target).hijack(), _throttle.throttle).call(_context, function () {
          return DeltaClass.scrollStop(root).hijack();
        });
      });

      if (sources.length > 1) {
        return this.merge.apply(this, _toConsumableArray(sources));
      } else {
        return sources[0];
      }
    }
  }, {
    key: 'scroll',
    value: function scroll() {
      var _context2;

      return (_context2 = this.scrollWindow.apply(this, arguments), _mergeAll.mergeAll).call(_context2);
    }
  }, {
    key: 'scrollWindow',
    value: function scrollWindow() {
      var _parseOpts3 = parseOpts.apply(undefined, arguments);

      var _parseOpts4 = _slicedToArray(_parseOpts3, 3);

      var target = _parseOpts4[0];
      var root = _parseOpts4[1];
      var DeltaObservableClasses = _parseOpts4[2];

      var sources = DeltaObservableClasses.map(function (DeltaClass) {
        var _context3;

        return (_context3 = DeltaClass.scrollStart(target).hijack(), _map.map).call(_context3, function (v) {
          var _context4;

          return (_context4 = DeltaClass.scroll(root).hijack(), _takeUntil.takeUntil).call(_context4, DeltaClass.scrollStop(root).hijack());
        });
      });

      if (sources.length > 1) {
        return this.merge.apply(this, _toConsumableArray(sources));
      } else {
        return sources[0];
      }
    }
  }, {
    key: 'scrollStop',
    value: function scrollStop() {
      var _parseOpts5 = parseOpts.apply(undefined, arguments);

      var _parseOpts6 = _slicedToArray(_parseOpts5, 3);

      var target = _parseOpts6[0];
      var root = _parseOpts6[1];
      var DeltaObservableClasses = _parseOpts6[2];

      var sources = DeltaObservableClasses.map(function (DeltaClass) {
        var _context5;

        return (_context5 = DeltaClass.scrollStart(target).hijack(), _mergeMap.mergeMap).call(_context5, function () {
          var _context6;

          return (_context6 = DeltaClass.scrollStop(root).hijack(), _take.take).call(_context6, 1);
        });
      });

      if (sources.length > 1) {
        return this.merge.apply(this, _toConsumableArray(sources));
      } else {
        return sources[0];
      }
    }
  }]);

  return Scrolljack;
}(_DeltaObservable2.DeltaObservable);

exports.default = Scrolljack;