"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var returnTrue = function returnTrue() {
  return true;
};
var returnFalse = function returnFalse() {
  return false;
};

var EmulatedEvent = exports.EmulatedEvent = function () {
  function EmulatedEvent(event) {
    var type = arguments.length <= 1 || arguments[1] === undefined ? event.type : arguments[1];

    _classCallCheck(this, EmulatedEvent);

    var Interface = this.constructor.Interface;

    for (var propName in Interface) {
      if (!Interface.hasOwnProperty(propName)) continue;
      var normalize = Interface[propName];
      if (normalize) {
        this[propName] = normalize(event);
      } else {
        this[propName] = event[propName];
      }
    }

    this.isDefaultPrevented = event.defaultPrevented ? returnTrue : returnFalse;
    this.isPropagationStopped = returnFalse;

    this.type = type;
    this.nativeEvent = event;
  }

  _createClass(EmulatedEvent, [{
    key: "preventDefault",
    value: function preventDefault() {
      this.defaultPrevented = true;
      if (this.nativeEvent.preventDefault) this.nativeEvent.preventDefault();
      this.isDefaultPrevented = returnTrue;
    }
  }, {
    key: "stopPropagation",
    value: function stopPropagation() {
      if (this.nativeEvent.stopPropagation) this.nativeEvent.stopPropagation();
      this.isPropagationStopped = returnTrue;
    }
  }]);

  return EmulatedEvent;
}();

EmulatedEvent.Interface = {
  type: null,
  target: null,
  currentTarget: null,
  eventPhase: null,
  bubbles: null,
  cancelable: null,
  timeStamp: function timeStamp(event) {
    return event.timeStamp || Date.now();
  },
  defaultPrevented: null,
  isTrusted: null
};
exports.default = EmulatedEvent;