'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AccumulationSubscriber = exports.AccumulationOperator = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Subscriber2 = require('rxjs/Subscriber');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var add = function add(a, b) {
  return parseFloat(a, 10) + parseFloat(b, 10);
};

var AccumulationOperator = exports.AccumulationOperator = function () {
  function AccumulationOperator(initialValue) {
    _classCallCheck(this, AccumulationOperator);

    this.initialValue = initialValue;
  }

  _createClass(AccumulationOperator, [{
    key: 'call',
    value: function call(subscriber, source) {
      source._subscribe(new AccumulationSubscriber(subscriber, this.initialValue));
    }
  }]);

  return AccumulationOperator;
}();

exports.default = AccumulationOperator;

var AccumulationSubscriber = exports.AccumulationSubscriber = function (_Subscriber) {
  _inherits(AccumulationSubscriber, _Subscriber);

  function AccumulationSubscriber(destination, initialValue) {
    _classCallCheck(this, AccumulationSubscriber);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(AccumulationSubscriber).call(this, destination));

    _this._value = initialValue;
    return _this;
  }

  _createClass(AccumulationSubscriber, [{
    key: '_next',
    value: function _next(value) {
      var next = _extends({}, this._value);

      for (var key in value) {
        if (key in next) next[key] = add(next[key], value[key]);else next[key] = value[key];
      }

      this._value = next;
      return _get(Object.getPrototypeOf(AccumulationSubscriber.prototype), '_next', this).call(this, next);
    }
  }]);

  return AccumulationSubscriber;
}(_Subscriber2.Subscriber);