var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { EmulatedUIEvent } from './EmulatedUIEvent';

export class EmulatedMouseEvent extends EmulatedUIEvent {

  getModifierState(key) {
    return this.nativeEvent.getModifierState(key);
  }
}

EmulatedMouseEvent.Interface = _extends({}, EmulatedUIEvent.Interface, {
  clientX: null,
  clientY: null,
  pageX: null,
  pageY: null,
  screenX: null,
  screenY: null,
  ctrlKey: null,
  shiftKey: null,
  altKey: null,
  metaKey: null,
  button: null,
  buttons: null,
  relatedTarget(event) {
    return event.relatedTarget || (event.fromElement === event.srcElement ? event.toElement : event.fromElement);
  }
});
export default EmulatedMouseEvent;