'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EmulatedTouchEvent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _EmulatedUIEvent2 = require('./EmulatedUIEvent');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EmulatedTouchEvent = exports.EmulatedTouchEvent = function (_EmulatedUIEvent) {
  _inherits(EmulatedTouchEvent, _EmulatedUIEvent);

  function EmulatedTouchEvent() {
    _classCallCheck(this, EmulatedTouchEvent);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(EmulatedTouchEvent).apply(this, arguments));
  }

  _createClass(EmulatedTouchEvent, [{
    key: 'getModifierState',
    value: function getModifierState(key) {
      return this.nativeEvent.getModifierState(key);
    }
  }]);

  return EmulatedTouchEvent;
}(_EmulatedUIEvent2.EmulatedUIEvent);

EmulatedTouchEvent.Interface = _extends({}, _EmulatedUIEvent2.EmulatedUIEvent.Interface, {
  touches: null,
  targetTouches: null,
  changedTouches: null,
  altKey: null,
  metaKey: null,
  ctrlKey: null,
  shiftKey: null
});
exports.default = EmulatedTouchEvent;