'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EmulatedUIEvent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _EmulatedEvent2 = require('./EmulatedEvent');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EmulatedUIEvent = exports.EmulatedUIEvent = function (_EmulatedEvent) {
  _inherits(EmulatedUIEvent, _EmulatedEvent);

  function EmulatedUIEvent() {
    _classCallCheck(this, EmulatedUIEvent);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(EmulatedUIEvent).apply(this, arguments));
  }

  return EmulatedUIEvent;
}(_EmulatedEvent2.EmulatedEvent);

EmulatedUIEvent.Interface = _extends({}, _EmulatedEvent2.EmulatedEvent.Interface, {
  view: function view(event) {
    if (event.view) return event.view;
    var target = event.target || event.srcElement || window;
    return target === target.window ? target : window;
  },

  detail: function detail(event) {
    return event.detail || 0;
  }
});
exports.default = EmulatedUIEvent;