'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HijackableEventObservable = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _symbolObservable = require('symbol-observable');

var _symbolObservable2 = _interopRequireDefault(_symbolObservable);

var _Observable2 = require('rxjs/Observable');

var _fromEvent = require('rxjs/observable/fromEvent');

var _filter = require('rxjs/operator/filter');

var _HijackOperator = require('../operators/HijackOperator');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HijackableEventObservable = exports.HijackableEventObservable = function (_Observable) {
  _inherits(HijackableEventObservable, _Observable);

  function HijackableEventObservable(target, event, predicate) {
    _classCallCheck(this, HijackableEventObservable);

    if (typeof target[_symbolObservable2.default] === 'function') {
      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(HijackableEventObservable).call(this));

      _this.source = target[_symbolObservable2.default]();
    } else {
      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(HijackableEventObservable).call(this));

      for (var _len = arguments.length, args = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
        args[_key - 3] = arguments[_key];
      }

      _this.source = _fromEvent.fromEvent.apply(undefined, [target, event].concat(args));
      if (predicate) {
        var _context;

        _this.source = (_context = _this.source, _filter.filter).call(_context, predicate);
      }
    }
    return _possibleConstructorReturn(_this);
  }

  _createClass(HijackableEventObservable, [{
    key: 'lift',
    value: function lift(operator) {
      var observable = new HijackableEventObservable(this);
      observable.operator = operator;
      return observable;
    }
  }, {
    key: 'hijack',
    value: function hijack(predicate) {
      return this.lift(new _HijackOperator.HijackOperator(predicate));
    }
  }], [{
    key: 'create',
    value: function create() {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return new (Function.prototype.bind.apply(HijackableEventObservable, [null].concat(args)))();
    }
  }]);

  return HijackableEventObservable;
}(_Observable2.Observable);

exports.default = HijackableEventObservable;