'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HijackSubscriber = exports.HijackOperator = undefined;

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Subscriber2 = require('rxjs/Subscriber');

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var HijackOperator = exports.HijackOperator = function () {
  function HijackOperator(predicate) {
    _classCallCheck(this, HijackOperator);

    this.predicate = predicate;
  }

  _createClass(HijackOperator, [{
    key: 'call',
    value: function call(subscriber, source) {
      return source._subscribe(new HijackSubscriber(subscriber, this.predicate));
    }
  }]);

  return HijackOperator;
}();

exports.default = HijackOperator;

var HijackSubscriber = exports.HijackSubscriber = function (_Subscriber) {
  _inherits(HijackSubscriber, _Subscriber);

  function HijackSubscriber(destination, predicate) {
    _classCallCheck(this, HijackSubscriber);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(HijackSubscriber).call(this, destination));

    _this.predicate = predicate;
    return _this;
  }

  _createClass(HijackSubscriber, [{
    key: '_next',
    value: function _next(value) {
      var _value$event = value.event;
      var event = _value$event === undefined ? value : _value$event;

      var shouldHijack = !event.defaultPrevented && typeof event.preventDefault === 'function' && (typeof this.predicate !== 'function' || this.predicate(event));
      if (shouldHijack) event.preventDefault();
      _get(Object.getPrototypeOf(HijackSubscriber.prototype), '_next', this).call(this, value);
    }
  }]);

  return HijackSubscriber;
}(_Subscriber2.Subscriber);